/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;

/**
   Translate the letter {@link P} along the x-axis while
   rotating around the y-axis.
 <p>
   This is one way to solve the problem, but it
   is not the best way.
*/
public class Example_23b
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Create a set of x and y axes.
      Model axes = new Axes2D(-5, +5, -5, +5, 20, 20);
      // Color them red.
      ModelShading.setColor(axes, Color.red);
      // Push the axes away from where the camera is.
      Position axes_p = new Position(axes);
      axes_p.matrix = Matrix.translate(0, 0, -5);
      // Add the axes to the Scene.
      scene.addPosition(axes_p);

      // Create a Model of the letter P.
      P modelP = new P();
      // Color the P blue.
      ModelShading.setColor(modelP, Color.blue);
      // Add the model to the Scene.
      Position modelP_p = new Position(modelP);
      scene.addPosition(modelP_p);


      // Push the model P away from where the camera is.
      modelP_p.matrix = Matrix.translate(0, 0, -5);

      // Translate along the x-axis while rotating around the y-axis.
      for (int i = 0; i <= 50; i++)
      {
         Matrix save = modelP_p.matrix; // Save the translation.

         modelP_p.matrix.mult( Matrix.rotate(i*36, 0,1,0) ); // Notice the difference in this rotation!

         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb.vp);
         fb.dumpFB2File(String.format("PPM_Example_23b_Frame%03d.ppm", i));

         modelP_p.matrix = save;   // Undo the rotation.
         modelP_p.matrix.mult( Matrix.translate(0.1, 0, 0) ); // Accumulate the translation.
      }
   }
}
